<?
/**
 * @package pyranometer
 * @author Akash Heimlich
 * @description This file is called every minute
 */
 {
//$_GLOBALS['pyra_cnt']=$_GLOBALS['pyra_cnt']+1;
//$_GLOBALS['pyra_min']+=$v*$_GLOBALS['pyra_mul'];
$cnt = $_GLOBALS['pyra_cnt'];
$min = $_GLOBALS['pyra_min'] / ($cnt*60);
$avg = $_GLOBALS['pyra_min'] / ($cnt);

print($_GLOBALS['pyra_cnt']);
$_GLOBALS['pyra_min']=0;
$_GLOBALS['pyra_day'] += $min;
mb_set_dev_var($_GLOBALS['pyra_id'],'kWh_Day_Irradiance',$_GLOBALS['pyra_day']);
mb_set_dev_var($_GLOBALS['pyra_id'],'kW_Potential_Average',$avg/1000*$_GLOBALS['pyra_plant_size']*$_GLOBALS['pyra_pr_ratio']);
mb_set_dev_var($_GLOBALS['pyra_id'],'kW_Potential_Active',$avg/1000*$_GLOBALS['pyra_plant_size']*$_GLOBALS['pyra_pr_ratio']);

$_GLOBALS['kWh_Day_Potential'] += ($avg/1000*$_GLOBALS['pyra_plant_size']*$_GLOBALS['pyra_pr_ratio'])/60;
mb_set_dev_var($_GLOBALS['pyra_id'],'kWh_Day_Potential',$_GLOBALS['kWh_Day_Potential']);

//if ($min) 
{
    $_GLOBALS['pyra_cnt']=0;
    $prefix='';
        if ($_SERVER['HW_PLATFORM']==11) {
            $prefix='0:';
        }
    if ($_SERVER['HW_PLATFORM']>=20)   // ULTRA
        $prefix=intval($_GLOBALS['log_drive']).':';    
    
    $irr=ini_get($prefix."/logs/Pyranometer.ini","config","kWh_Day_Irradiance",0);
    if ($irr!=$_GLOBALS['pyra_day']) {
        ini_set($prefix."/logs/Pyranometer.ini","config","kWh_Day_Irradiance",$_GLOBALS['pyra_day']);
        ini_set($prefix."/logs/Pyranometer.ini","config","kWh_Day_Potential",$_GLOBALS['kWh_Day_Potential']);
    }
        
    if ($_GLOBALS['ez']['inv']) {    
        if (!is_array($_GLOBALS['inv_kwh_midnight'])) {
            $_GLOBALS['inv_kwh_midnight']=array();
        
            for ($i=0;$i<sizeof($_GLOBALS['ez']['inv']);$i++) {
                $_GLOBALS['inv_kwh_midnight'][$i]=ini_get($prefix."/logs/Pyranometer.ini","config","inv".$i,0.0);
            }
        }
        if (!is_array($_GLOBALS['inv_kwh_today'])) {
            $_GLOBALS['inv_kwh_today']=array();
        }
        $total_kwh_today=0;
        
        for ($i=0;$i<sizeof($_GLOBALS['ez']['inv']);$i++) {
            $dev=mb_get_dev_by_id($_GLOBALS['ez']['inv'][$i]['id'],$_GLOBALS['ez']['inv'][$i]['bus']);
            if (intval($_GLOBALS['inv_kwh_midnight'][$i])<=0) { // in case it's no set
                $_GLOBALS['inv_kwh_midnight'][$i]=$dev['roleval3'];
                
                if ($_GLOBALS['inv_kwh_midnight'][$i]) {
                    ini_set($prefix."/logs/Pyranometer.ini","config","inv".$i,$_GLOBALS['inv_kwh_midnight'][$i]);
                }
            }
            if ($_GLOBALS['inv_kwh_today'][$i]<0) {
                $_GLOBALS['inv_kwh_today'][$i]=0;
            }
            if ($dev['roleval3']>$_GLOBALS['inv_kwh_midnight'][$i])
                $_GLOBALS['inv_kwh_today'][$i]=$dev['roleval3']-$_GLOBALS['inv_kwh_midnight'][$i];
            
            $total_kwh_today+=$_GLOBALS['inv_kwh_today'][$i];
            $_GLOBALS['total_kwh_today']=$total_kwh_today;
            
            if ($_GLOBALS['pyra_plant_size']) {
                $daily_pr =  ($total_kwh_today*100) / ($_GLOBALS['pyra_plant_size'] * ($_GLOBALS['pyra_day']/1000));
                $_GLOBALS['daily_pr']=$daily_pr;
                mb_set_dev_var($_GLOBALS['pyra_id'],"roleval10",$daily_pr);
            }
        }
        mb_set_dev_var($_GLOBALS['pyra_id'],'roleval11',intval($total_kwh_today));
    }
    
}
}
?>

